Hinweise zur Dokumentation

Diese Beschreibung wendet sich ausschließlich an ausgebildetes Fachpersonal der Steuerungs- und Automatisierungstechnik, das mit den geltenden nationalen Normen vertraut ist.
Zur Installation und Inbetriebnahme der Komponenten ist die Beachtung der nachfolgenden Hinweise und Erklärungen unbedingt notwendig.

Das Fachpersonal hat sicherzustellen, dass die Anwendung bzw. der Einsatz der beschriebenen Produkte alle Sicherheitsanforderungen, einschließlich sämtlicher anwendbaren Gesetze, Vorschriften, Bestimmungen und Normen erfüllt.

Disclaimer

Diese Dokumentation wurde sorgfältig erstellt. Die beschriebenen Produkte werden jedoch ständig weiter entwickelt.
Deshalb ist die Dokumentation nicht in jedem Fall vollständig auf die Übereinstimmung mit den beschriebenen Leistungsdaten, Normen oder sonstigen Merkmalen geprüft.
Falls sie technische oder redaktionelle Fehler enthält, behalten wir uns das Recht vor, Änderungen jederzeit und ohne Ankündigung vorzunehmen.
Aus den Angaben, Abbildungen und Beschreibungen in dieser Dokumentation können keine Ansprüche auf Änderung bereits gelieferter Produkte geltend gemacht werden.

Marken

Beckhoff®, TwinCAT®, EtherCAT®, Safety over EtherCAT®, TwinSAFE®, XFC® und XTS® sind eingetragene und lizenzierte Marken der Beckhoff Automation GmbH.
Die Verwendung anderer in dieser Dokumentation enthaltenen Marken oder Kennzeichen durch Dritte kann zu einer Verletzung von Rechten der Inhaber der entsprechenden Bezeichnungen führen.

Patente

Die EtherCAT Technologie ist patentrechtlich geschützt, insbesondere durch folgende Anmeldungen und Patente:
EP1590927, EP1789857, DE102004044764, DE102007017835
mit den entsprechenden Anmeldungen und Eintragungen in verschiedenen anderen Ländern.

Die TwinCAT Technologie ist patentrechtlich geschützt, insbesondere durch folgende Anmeldungen und Patente:
EP0851348, US6167425 mit den entsprechenden Anmeldungen und Eintragungen in verschiedenen anderen Ländern.

Copyright

© Beckhoff Automation GmbH & Co. KG, Deutschland.
Weitergabe sowie Vervielfältigung dieses Dokuments, Verwertung und Mitteilung seines Inhalts sind verboten, soweit nicht ausdrücklich gestattet.
Zuwiderhandlungen verpflichten zu Schadenersatz. Alle Rechte für den Fall der Patent-, Gebrauchsmuster- oder Geschmacksmustereintragung vorbehalten.


TwinCAT Simulation Manager

TS1110 | TwinCAT Simulation Manager

Neu in Version 2.1

In den bisherigen Version (TwinCAT Simulation Manager < Version 2.1) ist immer davon ausgegangen worden, dass eine lauffähige TwinCAT Umgebung (vorhandene Hardware, aktivierte System Manager Konfiguration und laufende SPS-Programme) existiert. Die Version 2.1 bietet jetzt Funktionalitäten zur Projektverteilung an, d.h. es ist über die Oberfläche des TwinCAT Simulation Manager möglich die Zielsysteme (Original- sowie Simulation), die zu nutzenden System Manager Konfigurationen sowie eventuell vorhandene PLC Projekte zuzuordnen und auf den verfügbaren Resourcen (CPUs) zu verteilen.

Diese Funktionalitäten werden unter dem Oberbegriff "Deployment" zusammengefasst und beinhalten:

  • Das Importieren/Exportieren von bestehenden System Manager Konfigurationen sowie die Zuordnung des Zielsystems.
  • Import/ Export, Erzeugung und Löschen von SPS-Projekten (mit Zuordnung einer unbenutzten SPS-Laufzeit).
  • Die Erzeugung von Bootprojekten aus der Simulations Manager IDE heraus.

Diese neuen Fähigkeiten vereinfachen es wesentlich ein bereit vorhandenes und lauffähiges Maschinenprojekte auf ein Simulations-, Demo- oder Schulungssystem zu transportieren. Die Möglichkeiten dieses System lokal bzw. verteilt zu betreiben wird voll unterstützt.

Weiterhin wurden die folgenden allgemeinen Erweiterungen und Verbesserungen implementiert:

  • Unterstützung von CNC Achsen (Schaltung der Konfigurierten Achsen in den CNC Simulation-Modus, CNC Handfunktionen)
  • Support von TwinCAT 2.11
  • Allgemeine Oberflächenerweiterungen u. viele kleine Verbesserungen.


TwinCAT Simulation Manager

TS1110 | TwinCAT Simulation Manager

Neu in Version 2.0

Der TwinCAT Simulation Manager hat bisher auf einer Steuerung die reale SPS/NC in einem Laufzeitsystem laufen lassen und den zu simulierenden Prozess in einem weiteren Laufzeitsystem. Um eine Trennung von realer SPS/NC und Simulationsprozess zu gewährleisten, wurde jetzt die Remotefähigkeit integriert. Damit kann auf dem Steuerungsrechner die reine Steuerung laufen und auf einem anderen PC der Simulationsprozess. Die Verbindung zwischen Steuerung und Simulationsprozess wird über Echtzeit-Ethernet und die TwinCAT-Netzwerkvariablen realisiert - was eine hochperformante und deterministische Anbindung garantiert.

Das lokale Szenario wird auch weiterhin unterstützt. Wenn die Simulation auf demselben Controller läuft, wird die Datenanbindung über IO-Prozessspeicher-Verknüpfungen realisiert. Diese haben im lokalen Kontext einen geringeren Overhead. Transparent für den Anwender wählt der TwinCAT Simulation Manager automatisch das am besten geeignete Daten-Transportprotokol abhängig vom Kontext der Anwendung - um die bestmögliche Performance zu erreichen.

Um die verteilte Controller Umgebung zu orchestrieren wurde der TwinCAT Simulation Manager mit vielen Funktionen und Oberflächenerweiterungen versehen:

  • Ein Navigations-/ Konfigurationsbaum für verteilte Umgebungen
  • Anmelden und Abmelden von Routen
  • Suchfunktionen für das Netzwerk (Intranet Broadcast search)
  • Debugging-Fähigkeiten für das Netzwerk (Ping, ADS Ping), Zustandskontrolle für die Controller
  • Cache and Backup Algorithmen für (verteilte) Symboldaten und Controller Konfigurationen
  • Möglichkeit der Zuordnung von Netzwerkadaptern für die Simulationskonfiguration
  • Methoden zum geordneten (orchestrierten) Starten, Stoppen, Restarten von Controllern und SPSen.

Allgemeine Erweiterungen und Verbesserungen:

  • Die Limitierung auf eine lokale SPS wurde aufgehoben. Simulationen können nun frei den verschiedenen SPS Laufzeiten zugeordnet werden.
  • Erneuerung und Erweiterung auf basis des .NET Framework 2.0
  • Allgemeine Oberflächenerweiterungen


TwinCAT Simulation Manager

Der 'TwinCAT Simulation Manager' ist ein leistungsfähiges Werkzeug zur Simulation von Maschinen bzw. Maschinenanlagen.

In verschiedenen Szenarien besteht die Anforderung eine Maschine oder Produktionsanlage ganz oder teilweise simulieren zu müssen:

  • Entwicklung
    Hardware und Software werden parallel von i.d.R. unterschiedlichen Leuten entwickelt und oder stehen zu unterschiedlichen Zeitpunkten zur Verfügung. Um die Anlage/Maschine in Teilen testen zu können ist eine Simulationsumgebung unabdingbar. Der 'TwinCAT Simulation Manager' unterstützt die Erzeugung einer "Virtuelle Maschine", die in ihrem Verhalten der realen Maschine entspricht. Aufgrund der Einbindung der Simulation in das Echtzeitsystem, sind hierbei sogar echtzeitkritische Anforderungen realisierbar (Echtzeitsimulation).
    --> Die Abhängigkeiten der Software von der Hardware reduzieren sich. Es wird sogar möglich, die Software vor der eigentlichen Inbetriebnahme fertig zu stellen. Die Qualität der Maschinensoftware erhöht sich durch Entwicklertests.
  • Abnahme der Software/Maschine vor der Inbetriebnahme
    Der 'TwinCAT Simulation Manager' ermöglicht die Implementierung von Abnahmeregeln in die Simulation. Dies kann normales Betriebsverhalten der Maschine/Anlage, aber auch Prüfungen auf Einhaltung von Schnittstellenspezifikationen sowie die Simulation von Störfällen sein. Die Qualitätssicherung bekommt ein leistungsfähiges Werkzeug an die Hand.
    --> Sicherstellung von Qualitäts-Leveln
  • Inbetriebnahme der Maschine/Anlage
    Die Inbetriebnahme von einzelnen Maschinenteilen wird ermöglicht. Durch vorhergehende Tests (siehe Abnahme der Maschine/Software vor der Inbetriebnahme) kann sich mehr auf die Parametrierung und Optimierung der Maschine konzentriert werden.
    --> Die Inbetriebnahmezeit reduziert sich deutlich.
  • In der Produktion
    Maschinen/Anlagenteile fallen aus, Materialengpässe können auftreten. Der 'TwinCAT Simulation Manager' ist in der Lage durch unterschiedliche Profile den Teilbetrieb der Maschine/Anlage aufrecht zu erhalten.
    --> Die Maschine/Anlage wird flexibler einsetzbar.
  • Ausbildung/ Schulung und Demonstration
    Die Simulation der (kompletten) Hardware ermöglicht es die Maschinensoftware rein virtuell auf einem Demosystem zu betreiben. Das Betriebs- u. Servicepersonal kann an diesem System geschult werden. Zusätzlich eignet sich eine so aufgesetzte Simulation die Maschine / Anlage in verschiedenen Szenarien zu demonstrieren.
    --> Unterstützt die Schulung von Personal

Alle diese Szenarios werden durch den TwinCAT Simulations-Manager unterstützt und geben dem Entwickler / Anlagenbetreiber umfangreiche Hilfsmittel zur Erstellung und Verwaltung von Simulationsumgebungen an die Hand:

  • Verwaltung und Konfiguration von Simulationsumgebungen / Profilen
  • Simulation von I/O-Geräten und Achsen
  • Einfaches und sicheres Umschaltung in den Simulationsmodus
  • Bibliotheken "Virtueller Geräte" und "virtueller Funktionen"
  • Automatische Erzeugung eines echtzeitfähigen Simulations-SPS-Projektrahmens mit Übernahme der Symbolik und Kommentare aus dem Originalprojekt
  • Nutzung aller Möglichkeiten der PLC-Control Programmierumgebung auch im Simulationscode:
    z.B. Graphisches Programmieren, Tracen, Debuggen usw.

Funktionsprinzip

E/A-Geräte und Achsen sind zunächst über Verknüpfungen mit der SPS verbunden. Sollen nun Teile der Maschine simuliert werden, so müssen die betroffenen Geräte inaktiv geschaltet werden. Damit die Maschinen-SPS - im folgenden Original-SPS genannt - weiterhin ihre Funktion ausüben kann, muss das Verhalten der relevanten Ein- und Ausgänge möglichst exakt nachgebildet werden. Dies übernimmt die Simulations-SPS, welche sich statt der inaktiven EA-Geräte in das System einhängt.

Zum Einkoppeln muss die Verknüpfung von der Original-SPS zum inaktiven Gerät gelöst und zur Simulations-SPS umgelenkt werden. Deaktivierte Achsen werden durch eine Simulations-Achse nachgebildet; eventuelle Latch-Funktionalitäten in der Simulations-SPS implementiert. Simulierte Achsen werden durch den 'TwinCAT Simulation Manager' in den 'Freilauf' geschaltet.

Bild 1: Prinzip des TwinCAT Simulation Managers

Das Nachbilden der I/O-Funktionalität in der Simulations-SPS wird durch einen Satz von Simulationsbausteinen vereinfacht. Komplexes Verhalten lässt sich durch Verbinden dieser Basisbausteine einfach zusammensetzen und in POEs kapseln bzw. wiederverwenden.

Der Datenaustausch zwischen SPS und E/A geschieht unter TwinCAT klassischerweise mit Hilfe von sogenannten E/A-Verknüpfungen. Der TwinCAT System Manager ermöglicht es diese Verknüpfungen anzulegen und bildet diese in adäquate Speicherkopieranweisungen in der TwinCAT Runtime ab (Task-Synchronisiertes Speicher-kopieren zwischen Prozessabbildern). Diese Art der Verknüpfung eignet sich allerdings nur im lokalen Nutzungszenario, d.h. innerhalb eines TwinCAT Systems innerhalb einer Resource (CPU), wo direkter Zugriff auf die beteiligten Prozessabbilder besteht.

In einer verteilten Umgebung - d.h. mehrere Resourcen/CPUs sind beteiligt - ist ein Datenaustausch zwischen den Geräten notwendig. Dieser könnte über eine diskrete Verdrahtung, einen Feldbus oder Netzwerktechnologie realisiert sein.

Um sowohl lokale als auch verteilte Umgebungen zu unterstützen, benutzt der TwinCAT Simulation Manager intern ein Verknüpfungsmodell, welches auf einer abstrakten Ebene angesiedelt und vom konkreten Datenaustausch-Protokoll transparent entkoppelt ist. Damit wählt der TwinCAT Simulation Manager abhängig vom Kommunikations-Anfangs u. Endpunkt immer das geeignetste Protokoll.

Momentan werden die folgenden Protokolle unterstützt:

  • TwinCAT EA-Verknüfung für lokale EA-Anbung (Höchster Datendurchsatz, limitiert vom Zyklus des Task-Masters)
  • Netzwerk Publisher-Subscriber Variablen für die Remote-Anbindung (EtherCAT Master-Master Protokoll, Datendurchsatz vom EtherCAT Protokoll bzw. seiner Zykluszeit begrenzt)

Diese transparente Behandlung von Remote-Geräten ermöglicht es sowohl die eigentliche Maschinensoftware (OriginalSoftware) als auch die angebundene Simulationssoftware frei auf den verfügbaren Resourcen (CPUs) zu verteilen und zu betreiben. Dabei lässt sich das System frei von einer rein lokalen Anwendung auf ein hochverteiltes Szenario skalieren.


Systemanforderungen

  • TwinCAT 2.10 Build 1325 oder neuer

  • Windows XP SP2 oder Windows Vista SP1 oder neuer

  • Microsoft .NET Framework Version 2.0 oder neuer


Funktionsweise des TwinCAT Simulation Managers

TS1110 | TwinCAT Simulation Manager

Unterstüzte Profile desTwinCAT Simulation Managers

Zwei verschiedene Konfigurationsprofile werden durch den TwinCAT Simulation Manager unterstützt (siehe Tabelle 1):

Profil | Beschreibung
Original | Alle Geräte und Hardware aktiviert (Original-Konfiguration)
Remote | Das System ist in den Simulations-Modus bzw. in das Simulations- Profil gesetzt. Nicht benutzte oder existente Hardware ist entkoppelt und / oder durch Simulations-Funktionalität ersetzt.

Tabelle 1: Simulations Profile

Das Original Profile wird implizit beim Import der TwinCAT System Konfigurationen durch den TwinCAT Simulation Manager gesetzt. Das Simulations-Profil wird als Delta zum Original-Profil in form von einer Liste von Simulations-Aktionen gespeichert.

Das Umschalten Original <--> Simulations-Modus wirkt auf verschiedene Komponenten der TwinCAT Konfiguration:

  • Ersetzen (oder mithören von I/Os) durch die Simulations-SPS (siehe Verknüpfungen von I/Os)
  • Ersetzen von physikalisch vorhandenen Achsen durch Simulations-Achsen (siehe Simulations-Achsen)
  • Deaktivierung von Geräten (siehe Geräte deaktivieren)

Verknüpfungen von I/Os

Der TwinCAT Simulations Manager folgt dem Konzept nicht verfügbare Geräte durch eine oder mehrere Simulations-SPSen zu ersetzen. Geräte-Signale, welche über die EA-Hardware übertragen werden üblicherweise in der SPS gesendet oder empfangen. Die Anbindung an die IOs geschieht innerhalb TwinCAT über sogannte EA-Mappings.

Über die Einstellungen im Simulations-Profil ist der TwinCAT Simulation Manager nun in der Lage, die Verknüfung zur EA aufzubrechen und durch eine Anbindung an die Simulations-SPS zu ersetzen. Dabei können eine oder mehre Simulations-SPSen lokal (Lokale-Simulation) oder entfernt über Netzwerk (Remote-Simulation) laufen. Der TwinCAT Simulation Manager wählt intern transparent für den Anwender das geeignetste Datenübertragungsprotokoll für die Symboldaten-Verknüfung zwischen Original und Simulations-SPS. Der Datenaustausch geschieht in Echtzeit, so daß die Maschineneigenschaften (speziell das Zeitverhalten der EA-Signale) bestmöglich emuliert werden können (Tabelle 2).

Simulations Typ | Bescrheibung
Lokal | Das Datentransportprotokoll ist als TwinCAT interne EA-Verknüpfungen realisiert, weil sie den geringsten Overhead haben. Der konkrete Datenaustausch geschieht über durch den EA-Treiber synchronisierte Prozessdatenkopieroperationen. Die Echtzeit-Fähigkeiten entsprechen denen der TwinCAT Echtzeitbasis.
Verteilt (Remote) | Das Datentransportprotokoll wird durch EtherCAT Netzwerkvariablen (Master-Master Kommunition) ausgeführt. Weil das Ethernet-Netzwerk beteiligt ist, ist der Overhead höher. DIe Echzeitfähigkeiten des Datenaustauschs entschrechen denen der EtherCAT Master-Master Komunikations (RT-EThernet).

Tabelle 2: Simulationstypen

Es sind verschiedene Arten von Verknüpfungen denkbar:

Art der Verknüpfung | Beschreibung
Beobachten (Observe) | Beobachten eines I/Os im Simulationsmodus. Ein Geräte-Eingang oder -Ausgang wird beobachtet. D.h. der Geräte-Eingange bzw. Ausgang wird auf einen Simulations-Eingang gegeben und steht dort zur weiteren Verarbeitung zur Verfügung. Im Original-Modus besteht die Verknüpfung zur Simulations-SPS nicht.
Simulieren (Simulate) | Simulieren eines I/Os, die Anbindung and das Gerät wird im Simulationsmodus entfernt. Die Verknüpfung zwischen Geräte-Eingang und Original-SPS-Eingang (bzw. Geräte Ausgang u. Original-SPS-Ausgang) wird aufgetrennt und durch die Simulations-SPS "simuliert". D.h. für Inputs liefert die Simulations-SPS die Werte für die Original-SPSen bzw. für Outputs werden die Original-SPS Werte in die Simulations-SPS gespeist. Im Original-Modus ist die "Umleitung" nicht aktiv.
Original | Keine Änderung im Simulationsmodus. Die Kommunikation zwischen Original-SPS und Gerät bleibt aktiv (soweit das Gerät nicht "Deaktiviert" ist, siehe Geräte deaktivieren)

Tabelle 3: Typen der Datenverknüpfung

Original Modus

Bild 1 zeigt eine TwinCAT System Konfiguration im nicht simulierten (original) Modus. Die rot und gelb gezeichneten aktiven Verknüpfungen verlaufen zwischen I/O-Geräten und den original SPSen. Die grau gezeichneten Verknüpfungen von/zu dem Simulations-SPSen sind inaktiv.

D.h. die Original SPSen kommunizieren mit den I/O-Geräten, welche vorhanden und aktiv sein müssen. Die Simulations-SPSen sind inaktiv und nehmen nicht an der Kommunikation teil (Original Modus).

Bild 1: TwinCAT System im Original-Modus

Die Verknüpfungen von und zur Simulations-SPS können "Lokal" oder "Remote" ausgeführt sein.

Simulations-Modus

Im Simulations-Modus (siehe Bild 2) sind die Simulations-SPSen hinzugeschaltet. Alle Verknüpfung zwischen Original SPSen und I/O-Geräten sind so umgeleitet, daß zu simulierende Geräte nicht mehr an der Kommunikation teilnehmen. Alle Funktionen der abgeschalteten Geräte, die im SimulationsModus vorhanden sein sollen, müssen durch eine oder mehrere Simulations-SPSen übernommen werden.

Die entkoppelten I/O-Geräte sind nun für den (Simulations-) Betrieb nicht mehr nötig.

Simulierte Verknüpfungen trennen die Verbindungen zum Gerät auf und übernehmen die Originalfunktion. Beobachter-Verknüpfungen speisen nur Prozesswerte in die Simulations-SPS ein, die Originalverknüpfung wird nicht aufgetrennt.

Bild 2: TwinCAT System im Simulations-Modus

Die Verknüpfungen von und zur Simulations-SPS können "Lokal" oder "Remote" ausgeführt sein.

Simulierte (virtuell) Achsen

Achsen, welche als 'Simuliert' gekennzeichnet sind, werden in den Simulationsmodus versetzt. Das bedeutet technisch, daß der Encoder der Achse durch einen Simulations-Encoder ersetzt wird und sich die Achse anschließend im Freilauf befindet. Der TwinCAT Simulation Manager merkt sich die Einstellungen der Original-Achse im Original Profil, so daß beim zurückschalten auf das Original-Profil diese wieder aktiviert werden können.

Deaktivierte Geräte

Mit 'Simuliert' gekennzeichnete Geräte werden im Simulationsmodus abgeschaltet (deaktiviert). Das Gerät braucht somit nicht mehr physikalisch vorhanden sein. Die Funktion des Gerätes, soweit benötigt für die Simulation, wird durch die Simulations-SPS übernommen.


TwinCAT Simulation Manager

TS1110 | TwinCAT Simulation Manager

Vorbereitungen für das Anlegen eines TwinCAT Simulation Manager Projektes

Mit der Version 2.1 vom TwinCAT Simulation Manager ist es nicht mehr notwendig, dass alle beteiligten Geräte die benötigten SPS-Programme laufen haben und die notwendige EA-Konfiguration vorweisen. SystemManager Konfigurationen sowie PLC Programme konnen nun importiert bzw. CPU Resourcen neu zugewiesen werden. Weitere Information hierzu gibt es im Kapitel Resourcenverteilung.

Die folgenden Hinweise sind nur für die Vorbereitung von Zielsystemen, Konfigurationen und SPS-Programmen sind als Leitfaden zu verstehen. Der TwinCATSimulation Manager ist nicht auf diese Einstellungen angewiesen, sie vereinfachen je nach Einsatzszenario das Handling jedoch beträchtlich.

SPS Programme

Alle SPS Programme sollten die SPS Simulation Bibliothek "TcSystem.lib" referenzieren. Neben den Basis-Simulationsbausteinen instanziert diese Bibliothek das Statusflag zur Anzeige des Simulations-Status innerhalb der SPS - einfach durch Hinzufügen der Bibliothek.

Weiterhin ist es hilfreich für die Bedienung des TwinCAT Simulation Managers alle SPS Projekte auch als "Bootprojekte" zu deklarieren (siehe Bild 1). Dadurch wird ein einfachereres Umschalten zwischen "Original" und "Simulations" Profilen ermöglicht. SPS Programme werden dann automatisch während des TwinCAT Restarts gestartet.

Eine Auswahl von "Remind to update boot project on change' innerhalb der PlcControl Projekteinstellungen (Bild 2) hilft das Bootprojekt konsistent zum aktuellen Projekt auf der Steuerung zu halten.

Ein Einpflegen der Symbolbeschreibungen für die verschiedenen SPS-Projekte in das Simulationsprojekt ist hilfreich. Es gibt zwei verschiedene Verfahren, wie diese Symbolbeschreibungen in das TwinCAT Simulation Manager Projekt importiert werden:

  1. Bei Verfügbarkeit der *.pro Datei und der zugehörigen *.tpy Datei auf dem Enwicklungsrechner werden diese Datein mit in das TwinCAT Simulation Manager Projekt kopiert.
  2. Die Symbolinformation wurde vorab durch den Projekt-Download mit auf dem Zielsystem abgelegt. Dazu muss die Option "Download Symbol description" im PlcControl (Bild 2) aktiviert und das kompilierte Projekt auf das Zielsystem geladen sein.

Um ein Simulations-SPS Projekt automatisch zu erzeugen, muss die Symbolik entweder nach Verfahren 1 oder 2 zur Verfügung stehen. Wird die Simulations-SPS komplett von Hand codiert, so ist ein Zugriff auf die Symbolik nicht notwendig.

Bild 1: Aktivierung von Bootprojekten aus der TwinCAT System Manager Konfiguration (System Manager Configuration)

Bild 2: Aktivierung des Symbol Dowonloades und dem "Update Boot Project Reminder" (PlcControl Option)

Zielsysteme

Es gibt die Möglichkeit die System Manager Configuration direkt auf dem Zielsystem zu speichern (Option "Auto Sichern im Zielsystem" Bild 3). Diese Option ist recht hilfreich, da sie die Konfiguration immer aktuell auf dem Target hält und nicht manuell auf den Entwicklungsrechner übertragen werden muss.

Beim Festlegen der zu benutzenden Zielsysteme durch den "Hinzufügen ..." Dialog (Bild 4) gibt es dann die Möglichkeit, die auf dem Zielsystem gespeicherte Konfiguration mit Bestätigung des Dialoges in das Simulations Manager Projekt heraufzuladen (Option "Lade Konfiguration vom Zielsystem"). Dieses Heraufladen geschieht nur einmalig, und es wird eine Kopie der Konfiguration lokal im Simulationsmanager-Projekt angelegt.

Bild 3: Speichern der System Manager Configuration auf dem Zielgerät (System Manager Option).

Bild 4: Auswahl von "Lade Konfiguration vom Zielsystem" um Zielsystem-seitige System Manager Konfigurationen hochzuladen (Simulation Manager Dialog).


First steps

TS1110 | TwinCAT Simulation Manager

Auswahl der Zielsysteme und Verteilung der Resourcen (Deployment)

Konzept

Der TwinCAT Simulation Manager unterstützt sowohl lokale als auch verteilte Szenarios. Um Realtime Funktionalitäten frei in einem System von einem bis mehreren Resourcen (CPUs) verteilen zu können müssen die folgenden Funktionalitäten realisert sein:

  • Auswahl der Zielsysteme
  • Zuordnung der Konfiguration
  • Zuordnung u. Verteilung der SPS Programme

Zwischen lokalen und verteilten Resourcen kann frei skaliert werden. Um sämtliche Daten einer Simulations-Projektes an einem zentralen Ort (meist auf dem Entwicklungsrechner) werden sämtliche Projektdaten im Simulations-Manager Projektverzeichnis zusammengeführt und dieses dient dann in der Folge als zentraler Datenspreicher. Beim Anlegen eines Simulationsmanager-Projektes bzw. bei der Auswahl von Resourcen und Programmen werden sowohl die System Manager Konfigurationen als auch die SPS-Projekte kopiert und im Projekt-Cache gespeichert. Diese Kopien sind in der Folge die Dateien auf denen gearbeitet wird - die Originale werden nicht verändert.

Auswahl der Zielsysteme

Der Dialog "Auswahl der Zielsysteme" wird über das Hauptmenü "Bearbeiten --> Zielsysteme auswählen" aufgerufen (siehe Bild 1).

Bild 1: Aufruf des "Auswahl der Zielsysteme" Dialoges

Der Dialog besteht im wesentlichen aus zwei Listboxen (siehe Bild 2):

  • Auf der linken Seite werden alle innerhalb des angebundenen Ethernet Netzwerkes gefundenen TwinCAT Systeme gelistet (Broadcast search)
  • Auf der rechten Seite werden alle im Simulationsprojekt eingebundenen Systeme aufgestellt.

Die Liste der eingebundenen Zielsysteme kann über die "<<" und ">>" Pushbuttons geändert werden.

Mit dem Bestätigen über "OK" wird die Liste der (zu simulierenden Systeme) aktiviert und der TwinCAT Simulation Manager lädt alle aktiven Konfigurations und die verfügbaren SPS Symbolbeschreibungen von den Targets in den Simulation Manager Projekt-Cache herunter. Danach wird das Navigationsfenster aktualisiert.

Bild 2: Auswahl der Zielsysteme

Zuordnung der Konfiguration

Bild 3: Kontextmenü Funktionen zum Zuordnen der System Manager Konfiguration (Zielsystembezogen)

Menü Eintrag | Beschreibung
Aktuelle Konfiguration Downloaden ... | Download der aktuellen Konfiguration vom Zielsystem. Die lokal gespeicherte Konfiguration im Simulations-Projekt wird überschreiben.
Löschen ... | Entfernen des Zielsystems und der zugehörigen Konfiguration aus dem SimulationsManager Projekt.
Zielsystem setzen ... | Setzt eine neue Zieladdresse an die selektierte Konfiguration. Die Konfiguration wird also einem neuen Gerät zugeordnet.
Importierte *.tsm ... | Importiert eine Konfiguration in das SimulationsManager Projekt und setzt die Zielsystem-Addresse dieser Konfiguration auf die Zielsystem-Addresse.
Exportiere *.tsm... | Kopiert die im Simulations-Projekt verwaltete System Manager Konfiguration in ein externes Verzeichnis.

Tabelle 2: Kontextmenü Funktionen zum Zuordnen der System Manager Konfiguration (Zielsystembezogen)

Zuordnung u. Verteilung der SPS-Programme

Bild 4: Kontextmenü Funktionen zum Zuordnen und Verteilen von SPS Programmen

Menü Eintrag | Beschreibung
Erzeuge Bootprojekt | Erzeugt das selektierte Bootprojekt auf dem Zielsystem.
Zuordnung SPS ... | Verschiebt das selektierte SPS-Programm auf eine andere verfügbare SPS-Laufzeit.
Importierte SPS-Projekt | Importiert das SPS-Program auf die selektierte SPS-Laufzeit. Das vorhande SPS-Program wird dabei überschrieben.
Exportiere SPS-Projekt | Exportiert das SPS-Program aus der selektierten SPS-Laufzeit aus dem Simulations-Projekt in ein externes Verzeichnis.
SPS Projekt hinzufügen ... | Fügt ein neues SPS Projekt hinzu. Dabei muss eine freie SPS-Laufzeit ausgewählt werden.
Löschen ... | Entfernt ein SPS-Program aus der Simulations-Konfiguration.

Tabelle 3: Kontextmenü Funktionen zum Zuordnen und Verteilen von SPS Programmen


First steps

TS1110 | TwinCAT Simulation Manager

Zuordnung von Orignal- und Simulations-SPSen

Bild 1: Aufruf des "SPS Projekt-Zuordnung Ändern" Dialoges

Bild 2: Zuordnung von Original-SPS zu Simulations-SPS


Simulationsmodus einschalten

Bei Betätigung des Simulationsbuttons im Original-Modus öffnet sich der folgende Wizard-Dialog (Bild 1).

Bild 1: Simulationsmodus mit der Wizard-Oberfläche einschalten

Die Beschreibung der Kommando-Pushbuttons befindet sich in Tabelle 1.

Push-Button Name | Beschreibung
Überspringen | Überspringt den Schritt (nur wenn er optional ist)
Ausführen | Führt einen Einzel-Schritt aus und hält danach an.
Alles Ausführen | Alle Schritte werden hintereinander ausgeführt. Wenn ein Fehler auftritt, wird sofort angehalten.
Abbrechen | Bricht die Ausführung der restlichen Schritte ab und schliesst den Wizard-Dialog.
Fertig | Erscheint wenn alle Schritte erfolgreich bearbeitet wurden. "Fertig" schließt den Wizard-Dialog.
Wiederholen | Erscheint, wenn ein Schritt mit Fehler abgebrochen wurde. "Wiederholen" wiederholt den momentan aktuellen Schritt.

Tabelle 1: Push-Buttons auf dem Wizard

Das Umschalten in den Simulationsmodus geschieht in mehreren Schritten (siehe Bild 1 und Tabelle 2). Diese Schritte sind teilweise notwendig und teilweise optional (d.h. sie können über den 'Überspringen' Button ausgelassen werden).

Schritt | Name | Beschreibung
1 | Setze Zielsystem(e) in den 'Config' mode | Alle beteiligten Zielsysteme werden in den 'Config' modus versetzt. Wenn das "lokale" System enthalten ist, so setzt der TwinCAT Simulation Manager zuerst ein "Reconfig" commando an dieses System ab. Sobald das lokale System den Konfigurations-Modus erreicht, wird das "Restart" Kommando an alle "remote" Systeme abgesetzt. Der Schritt ist erfolgreich abgearbeitet, wenn sich all Systeme im Konfigurations-Modus befinden.
2 | Simulations Einstellungen einspielen | Die momentanen I/O-Verknüpfungen werden auf die Simulations-SPS verbunden, Achsen werden in den Simulations-Modus geschaltet und Geräte werden deaktiviert! Die erzeugte Simulations-Konfiguration wird nicht benutzt, solange sie nicht aktiviert und das TwinCAT System einen Restart durchgeführt hat. Dieser Schritt ist erfolgreich abgearbeitet, wenn die Konfigurationseinstellungen erfolgreich gesetzt wurden.
3 | Speichern der TwinCAT Konfiguration(en) | Überschreibt alle System Manager Konfigurations-Dateien der beteiligten Systeme mit den im letzten Schritt erzeugten Konfigurations-Einstellungen.
4 | Aktivierung der aktuellen Konfiguration(en) | Markiert die Original-Konfiguration für die Benutzung beim nächsten TwinCAT Restart! Wenn dieser Schritt übersprungen wird, verwendet das TwinCAT System die alte Konfiguration und nicht die Simulations-Einstellungen! Die Konfiguration wird nicht aktiv solange kein TwinCAT Restart ausgeführt wird.
5 | Restarte ZIelsysteme | Startet die TwinCAT Systeme mit den zuletzt aktivierten Konfigurationen. Wie in Schritt 1 wird erst das (optionale) lokale System gestartet und dann parallel die "remote" Systeme. Der Schritt war erfolgreich, wenn sich alle System in "Run" befinden.
6 | Simulations-Status schreiben | Setzt den Wert der globalen SPS-Varialbe 'dwSimState' auf '1' in allen beteiligten SPSen. Dieses Symbol ist der Indikator für die SPSen, daß sich das System im 'Original' oder 'Simulations'-Modus befindet. Der Schritt war erfolgreich, wenn das Ziel erreichbar ist, das Symbol (TcSimManager.lib) im SPS-Projekt enthalten ist und er Wert erfolgreich heruntergeschrieben werden konnte.

Tabelle 2: Prozesschritte zur Umschaltung Simulations --> Original Mode

Wenn alle Schritte erfolgreich ausgeführt wurden, sieht der Wizard-Dialog wie in Bild 2 gezeigt aus.

Bild 2: Wizard Dialog wenn erfolgreich in den Simulatonsmodus zurückgeschaltet wurde

Der Wizard-Dialog kann nun über den "Fertig"-Pushbutton geschlossen werden.


Simulationsmodus ausschalten

TS1110 | TwinCAT Simulation Manager

Simulationsmodus ausschalten (zurück in den Original Modus)

Bei Betätigung des Simulationsbuttons im Simulations-Modus öffnest sich der folgende Wizard-Dialog (Bild 1).

Bild 1: Simulationsmodus mit der Wizard-Oberfläche ausschalten

Die Beschreibung der Kommando-Pushbuttons befindet sich in Tabelle 1.

Push-Button Name | Beschreibung
Überspringen | Überspringt den Schritt (nur wenn er optional ist)
Ausführen | Führt einen Einzel-Schritt aus und hält danach an.
Alles Ausführen | Alle Schritte werden hintereinander ausgeführt. Wenn ein Fehler auftritt, wird sofort angehalten.
Abbrechen | Bricht die Ausführung der restlichen Schritte ab und schliesst den Wizard-Dialog.
Fertig | Erscheint wenn alle Schritte erfolgreich bearbeitet wurden. "Fertig" schließt den Wizard-Dialog.
Wiederholen | Erscheint, wenn ein Schritt mit Fehler abgebrochen wurde. "Wiederholen" wiederholt den momentan aktuellen Schritt.

Tabelle 1: Push-Buttons auf dem Wizard

Das Umschalten in den Originalmodus geschieht in mehreren Schritten (siehe Bild 1 und Tabelle 2). Diese Schritte sind teilweise notwendig und teilweise optional (d.h. sie können über den 'Überspringen' Button ausgelassen werden).

Schritt | Name | Beschreibung
1 | Setze Zielsystem(e) in den 'Config' mode | Alle beteiligten Zielsysteme werden in den 'Config' modus versetzt. Wenn das "lokale" System enthalten ist, so setzt der TwinCAT Simulation Manager zuerst ein "Reconfig" commando an dieses System ab. Sobald das lokale System den Konfigurations-Modus erreicht, wird das "Restart" Kommando an alle "remote" Systeme abgesetzt. Der Schritt ist erfolgreich abgearbeitet, wenn sich all Systeme im Konfigurations-Modus befinden.
2 | Originale Einstellungen einspielen | Die momentanen I/O-Verknüpfungen werden von der Simulations-SPS gelöst, Achsen werden werdem in ihren ursprünglichen (Original) Modus geschaltet und simulierte Geräte werden wider aktiviert! Die erzeugte Simulations-Konfiguration wird nicht benutzt, solange sie nicht aktiviert und das TwinCAT System einen Restart durchgeführt hat. Dieser Schritt ist erfolgreich abgearbeitet, wenn die Konfigurationseinstellungen erfolgreich gesetzt wurden.
3 | Speichern der TwinCAT Konfiguration(en) | Überschreibt alle System Manager Konfigurations-Dateien der beteiligten Systeme mit den im letzten Schritt erzeugten Konfigurations-Einstellungen.
4 | Aktivierung der aktuellen Konfiguration(en) | Markiert die Original-Konfiguration für die Benutzung beim nächsten TwinCAT Restart! Wenn dieser Schritt übersprungen wird, verwendet das TwinCAT System die alte Konfiguration und nicht die Simulations-Einstellungen! Die Konfiguration wird nicht aktiv solange kein TwinCAT Restart ausgeführt wird.
5 | Restarte ZIelsysteme | Startet die TwinCAT Systeme mit den zuletzt aktivierten Konfigurationen. Wie in Schritt 1 wird erst das (optionale) lokale System gestartet und dann parallel die "remote" Systeme. Der Schritt war erfolgreich, wenn sich alle System in "Run" befinden.
6 | Simulations-Status schreiben | Setzt den Wert der globalen SPS-Varialbe 'dwSimState' auf '0' in allen beteiligten SPSen zurück. Dieses Symbol ist der Indikator für die SPSen, daß sich das System im 'Original' oder 'Simulations'-Modus befindet. Der Schritt war erfolgreich, wenn das Ziel erreichbar ist, das Symbol (TcSimManager.lib) im SPS-Projekt enthalten ist und er Wert erfolgreich heruntergeschrieben werden konnte.

Tabelle 2: Prozesschritte zur Umschaltung Simulations --> Original Mode

Wenn alle Schritte erfolgreich ausgeführt wurden, sieht der Wizard-Dialog wie in Bild 2 gezeigt aus.

Bild 2: Wizard Dialog wenn erfolgreich in den Originalmodus zurückgeschaltet wurde

Der Wizard-Dialog kann nun über den "Fertig"-Pushbutton geschlossen werden.


Simulations Template Projekt erzeugen

TS1110 | TwinCAT Simulation Manager

Simulations-Rahmenprojekt erzeugen

Über den Kontextmenüeintrag 'Erzeuge Simulations SPS-Projekt' auf der SPS Laufzeit, die simuliert werden soll, kann ein Simulations-Rahmen-SPS-Projekt erzeugt werden (Bild 1)

Innerhalb des nun erscheinenden Dialoges, muss eine freie SPS Laufzeit für das SImulations-SPS-Projekt ausgewählt werden (Bild 2). Dieser Dialog zeigt die momentan erreichbaren Zielsyteme. Wenn das vorgesehene Ziel nicht dabei ist, kann es über den "Suchen" Schalter hinzugefügt werden. Mit dem Verlassen des Dialoges über "OK" erzeugt der TwinCAT Simulation Manager einen Simulations-Projekt-Rahmen für die ausgewählte SPS, ordnet diesen dem ausgewählten Zielsystem bzw. der ausgewählten SPS-Laufzeit zu und integriert das SPS Projekt in das TwinCAT Simulation Manager Konfigurations-Projekt.

Dieser Simulations-SPS-Rahmen enthält nun alle lokierten EA-Symbole des Original-Projektes in gespiegelter From (Eingänge --> Ausgänge u. Ausgänge --> Eingänge, siehe Tabelle 1).

Bild 1: Erzeugen eine Simulations SPS-Projektes über Kontextmenü

Bild 2: Auswahl des SPS-Zielsystems

Die Vorlage wird aus dem selektierten original SPS-Projekt generiert. Dabei werden die folgende Elemente des Original-Projektes berücksichtigt und ggf. in das Simulations-SPS-Projekt übernommen.

  • Bibliotheken die im Standard PLC-Control Bibliothekspfad stehen ("[INSTALLATIONSPFAD]\Plc\Lib"]
  • Alle lokierten Ein- bzw. Ausgangssymbole (%I, %Q) der original SPS Projekte werden in das Simulationsprojekt übernommen. Ein- werden jedoch als Ausgänge und nach den in der Tabelle gezeugten Regeln erzeugt. Als Symbole gelten fest lokierte globale Variablen, fest lokierte Bausteinvariablen sowie VAR_CONFIGs (siehe auch 'Standardverknüpfungen')

    Original SPS Symbol

    Geräte-EA

    Signalrichtung

    Simulations SPS Symbol

    Beschreibung

    1 VAR_INPUT
    Lokierung(%I)     		Eingang <-- VAR_OUTPUT (%O) Ein Gerät liefert ein Signal an die SPS, z.B. ein "Ein"-Schalter. Im Simulationsmodus liefert die Simulations-SPS die Schalterstellung über ein Ausgangs-Symbol an die Original SPS.
    2 VAR_OUTPUT
    Lokierung %Q     		Ausgang --> VAR_INPUT (%I) Ein Bausteinausgangssignal wird auf ein Gerät gegeben. Z.B. ein 'bRunning' Flag auf eine Leuchte
    3 VAR_INPUT
    Lokierung %Q     		Ausgang --> VAR_OUTPUT (%I) Das Symbol spezifiziert das Interface zu einem Geräte-Eingang. Der Baustein ist i.d.R. nicht mit Code gefüllt
    4 VAR_OUTPUT
    Lokierung %I     		Eingang <-- VAR_INPUT (% Q) Das Symbol spezifiziert das Interface zu einem Geräte-Ausgang. Der Baustein ist i.d.R. nicht mit Code gefüllt

    Tabelle 1: Erzeugung von "spiegelbildlicher" Symbolik

    Bild 2: Fall 1 und 2 (Original Modus)

    Bild 3: Fall 1 und 2 (Simuliert)

  • Die Datentypen der lokierten Instanzen/Symbole
  • POEs, welche lokierte Symbole enthalten.
    POE Bausteine können weitere POEs enthalten. Diese werden, wenn lokierte Symbole enthalten sind, rekursiv erzeugt. Dabei werden jeweils die Ein- und Ausgänge, sowie deren Lokierungen gespiegelt.
    Die Generierung berücksichtigt nur Symbol / Instanzpfade, die zu einem lokierten Symbol führen. Andere Variablen, werden nicht erzeugt. Symbole, welche nach Erzeugung des Simulationsprojektes hinzugefügt wurden können über die Funktionalität Variablen nachträglich hinzufügen nachgepflegt werden.

Einschränkungen:

  • Eine Original SPS kann genau mit einer Simulations-SPS gemappt werden (lokale oder verteilte Simulation)
  • Lokierte Symbole aus Bibliotheken werden nicht unterstützt
  • Lokierte Pointer Datentypen werden nicht unterstützt

Die Simulations-SPS und kann nun mit dem Simulationscode gefüllt werden.

Dafür kann das TwinCAT PLCControl Programm über das Kontextmenü "Öffne PlcControl ..." geöffnet werden. Im Simulationsmodus werden die Original-Symbole mit Ihren Entsprechungen in der Simulations-SPS verbunden.


creating simulation template project

TS1110 | TwinCAT Simulation Manager

Variablen zum Simulationsprojekt hinzufügen

Der "Simulations-Symbole" hinzufügen Dialog bietet die Möglichkeit, das Simulationsprojekt nachträglich mit den Originalprojekten abzugleichen. Bevor der Dialog geöffnet wird, vergleicht der TwinCAT Simulations Manager die Original SPS Projekte mit dem Simulations-Projekt und bietet die nicht vorhandenen Symbole in der linken Auswahlbox ("Original-Projekte") an.

Bild 1: "Simulations Variablen hinzufügen" Kontextmenü auf der SPS Laufzeit des Navigationsbaumes

Bild 2: Auswahl der zum Simulationsprojekt hinzuzufügenden Symbole

Mit dem Verschieben der Symbole zur rechten Seite ("Simulations-Projekt") werden die zu ergänzenden Variablen ausgewählt.

Bild 3: Übertragen der Symbole in die Simulations-Projekt Liste

"OK" bestätigt und schließt den Dialog. Das "PLC Control" Programm wird im Anschluss gestartet und generiert die ausgewählten Symbole in das Simulations-SPS Projekt. Nachdem die Programmierumgebung wieder geschlossen ist, enthält der TwinCAT Simulations Manager die neuen Symbole im Navigationsbaum.


Standardverknüpfungen

Standardverknüpfungen sind Verknüpfungen, die vom Simulations-Manager automatisch mit einem einzigen Knopfdruck für das gesamte Projekt eingerichtet werden können. Diese Automatik wird für Symbole angeboten, die sowohl in der Original-SPS, als auch in der Simulations-SPS verfügbar sind (bei gleichem Datentyp) und wird über das Hauptmenü "Bearbeiten --> Erzeuge Standard Verknüfungen" ausgelöst (siehe Bild 1).

Bild 1: Aufruf von "Erzeuge Standard Verknüpfungen"

Daraufhin wird über alle Symbole aller Original SPSen iteriert, und versucht diese an Simulations-Symbole mit gleichem Symbolnamen / Zugriffspfac, identischem Datentypen sowie spiegelbildlicher Lokierung (%I <--> %Q) zu binden. Wenn ein entsprechendes Simulationssymbol exisitert, so erzeugt der TwinCAT Simulation Manager eine lokale (IO-Verknüpfung) oder Remote-Verknüpfung (über Netzwerkvariablen) zwischen Original- und Simulations-SPS im Simulationsprofil.

Die Standardverknüfungen sind sehr hilfreich, wenn sie in Verbindung mit der "'Simulations-Rahmenprojekt erzeugen' Funktion genutzt werden. Dieses Feature stellt sicher, daß Symbolische Namen und Zugriffspfade innerhalb des Simulationsprojektes immer zueinander passen / sowie gleiche Namen erhalten und somit einfach durch den Anwender und Programmautomatiken zu verbinden sind.

In Bild 2 hat das Navigationsfenster (linke Seite) das Symbol 'MAIN.bRun' markiert. Das Fenster ("Zielvariablen der Simulation", rechte Seite) zeigt die möglichen manuellen Verknüpfungsmöglichkeiten innerhalb des zugeordneten Simulations-SPS-Projektes. Die "Standard-Verknüfung" für dieses Symbol ist 'MAIN.bRun' auf der Simulationsseite und ist grün markiert.

Bild 2: "Zielvarablen der Simulation"-Fenster bevor die Standard-Verknüpfungen erzeugt wurden

Wenn die "Standard-Verknüpfungen" erzeugt wurden, ist das Original-Symbol "Main.bRun" an das Simulations-Symbol "Main.bRun" gebunden (im Simulationsprofil, siehe Bild 3). Alle angebundenden Symbole erhalten ein rotes 'S' innerhalb ihres Icons um eine erfolgte Simulationsanbindung zu kennzeichnen.

Bild 3: "Zielvariablen der Simulation"-Fenster nachdem die Standard Verknüpfungen erzeugt wurden.


Der Hauptbildschirm

Der Hauptbildschirm ist in drei verschiedene Bereiche aufgeteilt:

  • Dem Navigationsbaum (ähnlich dem System Manager Konfigurationsbaum, Überschrift "Konfiguration").
    Diese Ansicht wird zur Navigation durch die TwinCAT Simulation manager Konfiguration benutzt (geordnet nach den eingebundenen Zielsystemen).
  • Simulations-Konfigurationsfenster (Kontextabhängig, in Bild 1 werden die "Ziel-Symbole der Simulation" gezeigt)
  • Aktuelle Ansicht der Verknüpfungen vom selektierten Symbol ("Verbindungen")

Bild 1: Oberfläche des TwinCAT Simulation Managers

Ist der Simulations-Modus eingeschaltet, wird dies durch eine gelb-blinkenden Schriftzug "Sim" in der Statusleiste des Simulations-Managers angezeigt.

Das TwinCAT Icon am rechten Rand der Statusbar zeigt den aktuellen Status des lokalen TwinCAT Systems an.


Navigationsfenster

TS1110 | TwinCAT Simulation Manager

Das Navigationsfenster

Das Navigationsfenster dient zur Navigation durch die Simulation Manager Konfiguration. Es ist eng an den Konfigurationsbaum des System-Managers angelehnt. Verschiedene Funktionen können von hier angestoßen werden:

  • Simulation Ein- oder Ausschalten für verschiedene Elemente (Achsen, lokierte Symbole)
  • (De-)Aktivieren von Geräten
  • Öffnen der Eingebundenen PLC-Projekte
Das 'Navigationsfenster' ist das zentrale Benutzer Interface des TwinCAT Simulation Manager. Es fasst alle Funktionalitäten zusammen und ermöglicht das Navigieren durch die TwinCAT Simulation Manager Konfiguration. Sein Navigationsbaum ist eng an den Konfigurationsbaum des TwinCAT System Manager angelehnt, damit der Anwender leicht die Strukture seiner Maschinenkonfiguration wiedererkennen kann - eine Erweiterung erfolgte mit der Unterstützung von verteilten Systemen und Simulations-Konfigurationen.

Die Hauptaufgaben des 'Navigationsfensters' sind:

  • Navigation durch das Verteilte Systesm und der Zugriff auf Programmier- / Konfigurations- und Debugging-Werkzeuge bzw. Programme
  • Die Verwaltung von Original- und Simulationsprofilen
  • Die Konfiguration und Erzeugung von Simulationen für verschiedenste Projektelemente (z.B. Achsen, SPSen, EA Sensoren / Aktoren, Geräte ...)

Ein Beispiel für den Navigationsbaum wird in Bild 1 gezeigt.

Bild 1: Navigationsfenster des TwinCAT Simulation Managert

Knoten-Elemente welche mit Simulations-Einstellungen parametrisiert sind (z.B. Symbolvariablen, Achsen, Geräte, SPS-Projekte, ...) erhalten ein rotes 'S' in ihrem Knotensymbol.

Die verschiedenen Funktionalitäten des TwinCAT Simulation Manager werden hauptsächlich über das 'Navigationsfenster'-Kontextmenü angestossen. Abhängig vom selektierten Knoten in dieser Ansicht zeigt das Kontextmenü eine Auswahl der Kommandos in Tabelle 1.

Menü-Eintrag | Aktivierungs-Kontext | Beschreibung
Erzeuge Simulations-SPS | Original SPS selektiert, Simulations SPS ist nicht zugeordnet | Ein SPS-Simulations Rahmen-Projekt wird erzeugt und an die ausgwählte Original-SPS gebunden (siehe Simulations Rahmen-Projekt erzeugen).
Simulations Variablen hinzufügen ... | Original SPS selektiert, Simulations SPS zugeordnet | Pflegt nicht vorhandene Symbole aus der Original-SPS in die angebundene Simulations-SPS nach (see Variablen zum Simulationsprojekt hinzufügen).
SPS-Symbole herunterladen | SPS selektiert | Lädt die *.tpy Symbolinformation vom Zielsystem herunter und speichert sie im lokalen Cache. Eventuell bereits vorhandene Informationen werden überschrieben.
Importiere SPS-Projekt ... | SPS selektiert | Importiert ein "externes" SPS Projekt in den lokalen Cache. Es muss sichergestellt werden, dass nur Projekte importiert werden, die das momentan auf dem Zielsystem laufende Projekt räpresentiert!
Öffne PlcControl | SPS selektiert | Öffent das PLCControl program für die ausgwählte PLC. Die Vorbedingung ist, dass das *.pro file bereits durch den TwinCAT Simulation Manager importiert wurde (durch Simulationsprojekt erzeugen, oder durch das Importiere SPS-Projekt Kommando.
Neu einlesen | SPS selektiert | List die SPS-Symbolik neu ein.
Ping | Zielsystem ausgewählt | Pinged das Zielsystem mit UDP an. Wenn das Zielsystem über Netzwerk (UDP-Protokoll) erreichbar und eingeschaltet ist, meldet das Gerät eine erfolgreiche Antwort.
AdsPing | Zielsystem ausgewählt | Pinged das Zielsystem mit ADS an. Zusätzlich zur Erreichbarkeit des Zielsystems via UDP müssen für den ADS Ping das lokale Gerät und das 'remote' Gerät eine TwinCAT Umgebung laufen haben (in 'Run' oder 'Config' Modus) und beide Systeme müssen über ihre ADS Router gegenseitig über sogenannte Routen angemeldet sein.
Öffne System Manager | Zielsystem ausgewählt | Öffent den TwinCAT System Manager mit der lokal gecacheten Konfiguration. Dies Konfiguration (*.tsm) sollte immer die aktuelle Konfiguration des Zielsystems sein.
Aktuelle Konfiguration downloaden ... | Zielsystem ausgewählt | Lädt die aktuelle Konfiguration vom Zielsystems herunter.
SPS Exploer | Zielsystem ausgewählt | Zeigt ein Navigationsfenster, welches die aktuellen SPS-Laufzeiten des Zielsystems anzeigt.
Konfigurations übers Web ... | Zielsystem ausgewählt | Öffnet die Default-Web-Konfigurations (HTML) Ansicht des Zielsystems. Wenn die Seite nicht durch das Zielsystem unterstützt wird, oder der Web-Server auf dem Zielsystem nicht läuft, wird eine Fehlermeldung angezeigt.
Deaktivieren | Gerät(e) ausgewählt | Deaktiviert das / die Gerät(e) im Simulations-Profil
Aktivieren | Gerät(e) ausgewählt | Aktiviert das / die Gerät(e) im Simulations-Profil
Simulation | Achse ausgewählt | Entkoppelt die Achse und setzt den Simulations-Encoder im Simulations-Profil.
Eigenschaften | Alles | Öffnet den 'Eigenschaften' Dialog.

Tabelle 1: Kontextmenü Kommandos

Im folgenden werden ein paar Beispiele für das Kontextmenü auf den wichtigsten Navigations-Knoten gegeben:

Variablen oder Achsen, die im Simulationsmodus anders verknüpft werden, erhalten in ihrem Icon ein rotes S in der linken oberen Ecke.

Bild 2: Kontextmenü bei selektierter Original SPS wenn bereits ein Simulations-SPS zugeordnet wurde

Bild 3: Kontextmenü bei selektierter Original-SPS wenn noch keine Simulations-SPS zugeordnet wurde

Bild 4: Kontextmenü selektiertem Zielsystem

Bild 5: Kontextmenü bei selektiertem Gerät

Bild 5: Kontextmenü bei Selektierter Achse


Projektinformation

Der "Projektinformations-Dialog" zeigt Informationen über die verwendeten Laufzeitumgebungen an. Wenn das "Simulations-Flag" in der SPS gesetzt ist, so werden die entsprechenden Elemente gelb markiert.

Bild 1: Zielgeräte-Steuerungs-Dialog

Bild 1: SPS-Status Dialog


Einstellungs-Dialog

Bild 1: Der 'Einstellungen' Dialog

Option

Beschreibung
Prüfe Konfiguration auf Inkonsistenzen In TwinCAT System Manager Konfigurationsdateien Dateien (*.wsm oder *.tsm) die mit einer TwinCAT Version vor <2.9 erstellt wurden können nicht eindeutige Knotennamen vorkommen, d.h. im selben Unterzweig ist derselbe Knotenname zweimal vergeben. Mit Version 2.9 angelegte Konfigurationen enthalten diese Mehrdeutigkeiten nicht mehr.

Um eine einwandfreie Funktion des TwinCAT Simulations-Managers zu gewährleisten, müssen die Inkonsistenzen aufgelöst werden. Dazu gibt es einen Prüfmechanismus, welcher die System Manager Konfiguration beim Anlegen eines neuen Simulations-Manager-Projektes prüft und ggf. entsprechende Fehlermeldungen ausgibt.

Da diese Prüfung aufwändig ist und eine gewisse Zeit dauert, ist sie abschaltbar. Dies sollte allerdings nur geschehen, wenn sichergestellt ist, dass in den verwendeten Konfigurationen keine Inkonsistenzen mehr vorhanden sind.

Für neuere TwinCAT SystemManager Konfigurationen kann diese Prüfung abgeschaltet werden.
Startbildschirm unterdrücken | Unterdrücken des Startbildschirmes (Splashscreen)
Dialogfading unterdrücken | Das sanft Ein- und Ausblenden des Splashscreens und der Programmfortschritt-Dialoge wird unterdrückt.

Tabelle 1: Optionen des 'Einstellungen'-Dialoges

Die Einstellungen werden als Anwender-Einstellungen gespeichert.


Achsenansicht

Bei Aktivierung eines "Achsen"-Gruppenknotens im Navigationsbaum öffnet sich rechts eine Liste von Achsen. Diese Achsen können hier über das Kontextmenü als "Simuliert" oder "Original" gekennzeichnet werden.

Bild 1: Achsenansicht

Jede Simulierte Achse erhält eine Kennzeichnung im Icon.

Name | Beschreibung
Simulation | Markiert die Achse für die Simulation.
Original | Entfernt die Simulationseinstellung für die Achse.

Tabelle 1: Kontextmenüfunktionen in der Achsenansicht


Achsenansicht

Die Achsenansicht zeigt online Daten der Achse. Wenn sich die Achse im Simulationsmodus befindet, sind die Bedienelemente für die "Handfunktion" der Achse aktiv.

Bild 1: Achse im Simulationsmodus


Ansicht Simulierte Variablen (oder Original Variablen)

TS1110 | TwinCAT Simulation Manager

Ansicht "Konfiguration von Simulierten Symbolen"

Das Fenster "Variablen der Simulation" zeigt die aktuellen und die auswählbaren Verknüpfungen für ein Variablensymbol, welches im Navigationsfenster ausgewählt selektiert ist. Wird ein Symbol einer Original-SPS ausgewählt ist erscheinen in der Auswahlliste nur Variablen der Simulations-SPS. Ist eine Simulationsvariable i markiert, so erscheinen nur Original-Symbole. Diese umgekehrte Richtung wird durch eine geänderte Fensterüberschrift kenntlich gemacht (es erscheint anstatt "Variablen der Simulation" "Variablen der Original SPS"

Selektierbar (per CheckBox) sind immer nur Symbole des gleichen Datentyps und mit gespiegelten Lokierungen (Eingänge nur mit Ausgängen, oder Ausgänge mit Eingängen)

Bild 1: Markiertes Variablen Symbol im Navigationsfenster und "Variablen der Simulation" Ansicht

Eventuell erkannte Standard-Verknüpfungen werden grün markiert.

Bild 2: Einstellung der Simulationsverknüpfungen

Über die Checkboxen im Ansichtsfenster oder über das Kontextmenü können die Simulationseinstellungen wie folgt geändert werden:

Art der Verknüpfung | Beschreibung
Beobachten (Observe) | Beobachten eines E/As
Simulieren (Simulate) | Simulieren eines E/As, die Anbindung and das Gerät wird im Simulationsmodus entfernt
Original | Keine Änderung im Simulationsmodus

Tabelle 1: Kontextmenü Kommandos in der Ansicht "Konfiguration von Simulierten Symbolen"

Variablen oder Symbole, die im Simulationsmodus anders verknüpft werden, erhalten in ihrem Icon ein rotes S in der linken oberen Ecke.


Verbindungsfenster

TS1110 | TwinCAT Simulation Manager

Ansicht Aktuelle Verknüpfungen

Das Ansichtsfenster "Verbindungen" zeigt die aktuell aktiven Verknüpfungen des in der Navigationsansicht selektierten Symbols. Abhängig vom eingestellten Profil (Original oder Simulation) und des Simulationstypen (Lokal oder Remote) wird das Original-Symbol an EA-Geräte, an andere SPSen oder an Publisher/Subscriber Netzwerkvariablen angebunden sein (Eingestellt durch die Ansicht Konfiguration von Simulierten Symbolen).

Beispiel:

Das momentan aktivierte Profil ist 'Original'. Das Symbol 'MAIN.bRun' aus der Original SPS ist auf einen Digitalen Eingang an einem BK9000 gebunden (Bild 1).

Bild 1: Markiertes Symbol 'fCurrentPosition' im Navigationsfenster

Im Simulations-Profil ist das Symbol 'MAIN.bRun' an eine Netzwerk Subscriber Variable namens 'MAIN.bRun' gebunden (Bild 2). Die Netzwerkvariable erhält ihre Daten von einem System mit der Addresse 5.1.48.196.1.1.

Bild 2: Das Verbindungsfenster


Hauptmenü "Datei"

TS1110 | TwinCAT Simulation Manager

Hauptmenü 'Datei'

Menü-Eintrag | Beschreibung
Neu | Neues Simulations-Manager Projekt erzeugen
Öffnen | Öffnen eines bestehenden Simulations-Manager Projektes
Schließen | Schließen des aktuell geöffneten Simulations-Manager Projektes
Speichern | Speichern des aktuell geöffneten Simulations-Manager Projektes
Speichern unter | Speichern des aktuell geöffenten Simulations-Manager Projektes unter anderem Namen
Zielgeräte Status ... | Öffnet den Zielgerätesteuerungs-Dialog. Dieser zeigt den aktuellen Status der konfigurierten Zielsystem und gibt die Möglichkeit diese zu Starten und zu Stoppen.
SPS Status ... | Öffnet den SPS-Status-Dialog. Hier wird der Status der Konfigurierten SPSen und Ihren Tasks gezeigt.
Beenden | Beenden des Simulationsmanagers

Tabelle 1: Kommandos des 'Datei' Hauptmenüs

Bild 1: Das 'Datei' Hauptmenü


Hauptmenü "Bearbeiten"

TS1110 | TwinCAT Simulation Manager

Hauptmenü 'Bearbeiten'

Menü Eintrag | Beschreibung
Simulieren | Wechselt den TwinCAT Simulation Manager Modus zwischen Simulations Profil und Original Profil.
Überschreibe Gerätekonfiguration ... | Setzt das aktuelle Profil erneut. All dazugehörigen TwinCAT Simulation Manager Konfigurations-EInstellungen werden erneut eingespielt.
SPS Projekt Zuordnungen ... | Öffnet den Dialog zum Simulations SPS Zuordnungen.
Setze Simulations Status in SPS-Laufzeiten | Schreibt das Simulations Flag in alle eingebundenen SPSen (siehe SPS Simulations Bibliothek TcSimMan.lib. Das 'dwSimState' symbol wird mit dem entsprechenden Wert überschrieben (0: für Original-Profil, 1: für Simulations-Profil)
Simulations Variablen hinzufügen ... | Öffnet den "Variablen zum Simulation hinzufügen" Dialog. Dieses Kommando wird dazu benutzt um nachträglich hinzugefügte Symbole der Original-SPS in die Simulations-SPS hinzuzufügen.
Zielsysteme auswählen ... | Öffnet den Dialog zum Hinzufügen / Entfernen von Zielsystemen.
Erzeuge Standard-Verknüpfungen | Erzeugt die Standard-Verknüpfungen zwischen Orginal-SPSen und zugeordneten Simulations-SPSen (siehe Standardverknüpfungen). Eventuelle voreingestellte Bindungen werden verworfen.
Verwerfe Simulations-Einstellungen | Alle Simulations-Einstellungen werden zurückgesetzt.
Überprüfe Konfiguration | Das TwinCAT Simulation Manager Projekt wird auf Konsistenz geprüft.
Rescan PLC projects | Die Symbole aller SPSen werden neu eingelesen

Tabelle 1: Kommandos des 'Bearbeiten' Hauptmenüs

Bild 1: Das 'Bearbeiten' Hauptmenü


Overview

TS1110 | TwinCAT Simulation Manager

Hauptmenü 'Extras'

Menü-Eintrag | Beschreibung
Sprachen Einstellung der Sprachen (Benutzerabhängig)

Unterstüzte Sprache:

  • Englisch
  • Deutsch
Einstellungen | Öffnet den TwinCAT Simulation Manager Einstellungs-Dialog

Tabelle 1: Kommandos des 'Extras' Hauptmenüs

Bild 1: Das 'Extras' Hauptmenü


Hauptmenü "Ansicht"

TS1110 | TwinCAT Simulation Manager

Hauptmenü 'Ansicht'

Menü-Eintrag | Beschreibung
Aktionen | Öffnet den Simulations-Aktionen-Dialog.
Referenzen | Öffnet den Übersichtsdialog über die Aktuellen Verknüpfungen.

Tabelle 1: Kommandos des 'Ansicht' Hauptmenüs

Bild 1: Das 'Ansicht' Hauptmenü


Hauptmenü "Ansicht"

TS1110 | TwinCAT Simulation Manager

Dialog 'Simulations Aktionen'

Der 'Simulations Aktionen' zeigt die Einstellungs-Aktionen an, welche nötig sind, um das TwinCAT Simulation Manager Profil von 'Original' auf 'Simulation' umzuschalten.

Bild 1: Der 'Simulations Aktionen Dialog'


Hauptmenü "Ansicht"

TS1110 | TwinCAT Simulation Manager

Dialog 'Aktuelle Verknüpfungen'

Der Übersichtsdialog 'Aktuelle Verknüpfungen' zeigt alle aktuellen Verknüpfungen der beteiligten Zielsystem an.

Bild 1: Der Übersichtsdialog 'Aktuelle Verknüpfungen'


Hauptmenü "Ansicht"

TS1110 | TwinCAT Simulation Manager

Dialog "Broadcast Suche"

Der Dialog "Broadcast Suche" hilft Zielsysteme im Intranet zu finden und zu selektieren.

Bild 1: Der Dialog "Broadcast Suche"

Funktion | Beschreibung
Broadcast Suche | Sucht nach allen TwinCAT Geräten im Netzwerk und zeigt diese in der Liste an.
Suche Zielsystem | Sucht nach einem TwinCAT Gerät mit einem bestimmten Namen (HostName), einer bestimmten AmsNetID oder einer bestimmten IPAddresse.
Route Hinzufügen | Fügt das selektierte Zielsystem als (Remote) dem lokalen System hinzu (wechselseitig).
Route Entfernen | Entfernt das selektierte Zielsystem von den lokalen Routen (wechselseitig).
OK | Schliesst den Dialog.

Tabelle 1: Funktionen des Dialoges "Broadcast Suche"

Bild 2: Kontextmenü des Dialoges "Broadcast Suche"

Menü Eintrag | Beschreibung
Aktualisieren | Setzt sofort einen neuen Broadcast Search ab und aktualisiert die Liste der Zielsystem.
Ping | Pinged das Zielsystem mit UDP an. Wenn das Zielsystem über Netzwerk (UDP-Protokoll) erreichbar und eingeschaltet ist, meldet das Gerät eine erfolgreiche Antwort.
AdsPing | Pinged das Zielsystem mit ADS an. Zusätzlich zur Erreichbarkeit des Zielsystems via UDP müssen für den ADS Ping das lokale Gerät und das 'remote' Gerät eine TwinCAT Umgebung laufen haben (in 'Run' oder 'Config' Modus) und beide Systeme müssen über ihre ADS Router gegenseitig über sogenannte Routen angemeldet sein. Der Eintrag erscheint nur, wenn das selektierte System eine lokal angemeldete Route ist.
Zeige Ziel-Routen | Zeigt die am selektierten Zielsystem angemeldeten Routen. Der Eintrag erscheint nur, wenn das selektierte System eine lokal angemeldete Route ist.
Route hinzufügen ... | Fügt das ausgewählte Gerät auf dem lokalen System als Route hinzu (wechselseitig).
Route entfernen ... | Entfernt die aktuell ausgewählte verbundene Route vom lokalen System (wechselseitig).
Eigenschaften | Zeigt die Eigenschaften des aktuell ausgewählten Zielsystems an.

Tabelle 2: Kontextmenü des Dialoges "Broadcast Suche"


Hauptmenü "Ansicht"

TS1110 | TwinCAT Simulation Manager

Dialog 'Auswahl der Zielsysteme'

Mit dem Dialog "Auswahl der Zielsysteme" werden die im Simulationsprojekt eingebundenen Zielsysteme verwaltet.

Bild 1: Dialog "Auswahl der Zielsysteme"

Bild 2: Context-Menü im Dialog "Auswahl der Zielsysteme"

Menü Eintrag | Beschreibung
Finde Zielsysteme ... | Sucht nach Zielsystemen und meldet Routen an.
Aktualisieren | Setzt sofort einen neuen Broadcast Search ab und aktualisiert die Liste der Zielsystem.
Web Zugriff ... | Öffnet die Default-Web-Konfigurations (HTML) Ansicht des Zielsystems. Wenn die Seite nicht durch das Zielsystem unterstützt wird, oder der Web-Server auf dem Zielsystem nicht läuft, wird eine Fehlermeldung angezeigt.
Remote Desktop ... | Öffnet den "Remote Desktop"-Dialog, welcher die Arbeitsfläche des Zielsystems anzeigt.
Ping | Pinged das Zielsystem mit UDP an. Wenn das Zielsystem über Netzwerk (UDP-Protokoll) erreichbar und eingeschaltet ist, meldet das Gerät eine erfolgreiche Antwort.
AdsPing | Pinged das Zielsystem mit ADS an. Zusätzlich zur Erreichbarkeit des Zielsystems via UDP müssen für den ADS Ping das lokale Gerät und das 'remote' Gerät eine TwinCAT Umgebung laufen haben (in 'Run' oder 'Config' Modus) und beide Systeme müssen über ihre ADS Router gegenseitig über sogenannte Routen angemeldet sein. Der Eintrag erscheint nur, wenn das selektierte System eine lokal angemeldete Route ist.
Neustart ... | Neustart des Zielsystems.
Herunterfahren ... | Herunterfahren des Zielsystems.
Zeige Ziel-Routen | Zeigt die am selektierten Zielsystem angemeldeten Routen. Der Eintrag erscheint nur, wenn das selektierte System eine lokal angemeldete Route ist.
Route entfernen ... | Entfernt die aktuell ausgewählte verbundene Route.
Eigenschaften | Zeigt die Eigenschaften des aktuell ausgewählten Zielsystems an.

Tabelle 1: Context-Menü im Dialog "Auswahl der Zielsysteme"


Simulations SPS Bibliothek (TcSimManager.lib)

TS1110 | TwinCAT Simulation Manager

Simulations-SPS Bibliothek (TcSimManager.lib)

Soll eine SPS über den TwinCAT Simulations-Manager simuliert werden, müssen die Original-SPSen und die Simulations-SPS die TcSimManager.lib enthalten.

Globale Variablen

Die TcSimManager.lib enthält das globale DWORD 'dwSimState', über die die SPSen über den aktuellen Status der Simulation informiert werden.

      VAR_GLOBAL
    dwSimState : DWORD;END_VAR
Flag | Beschreibung
0 | Simulations-Modus ein / aus Das Flag wird vom TwinCAT Simulations-Manager gesetzt, wenn erfolgreich in den Simulations-Modus umgeschaltet wurde. An dieser Stelle ist der Modus durch die SPS auslesbar.
1 - 31 | Reserviert

Bausteine

Name | Beschreibung
FB_SimDelayedLatch | Verzögertes Latch
FB_SimPosMotor | Positionsgesteuerter Simulations-Motor.
FB_SimSimpleVeloMotor | Einfacher geschwindigkeitsgesteuerter Simulations-Motor
FB_SimVeloMotor | Geschwindigkeitsgesteuerter Simulations-Motor

Hilfsbausteine

Name | Beschreibung
FB_SimClock | Taktbaustein
FB_SimDelay | Verzögerungsbaustein
FB_SimDerivative | Ableitungsbaustein
FB_SimIntegral | Integrierbaustein
FB_SimPastCpuCounterTicks | Zeitmessungsbaustein
FB_SimRamp | Rampenbaustein


FUNCTION_BLOCK FB_SimClock

Taktbaustein mit variabler Pulsweite.

Bild 1: Funktionsblock FB_SIMCLOCK

VAR_INPUT

      VAR_INPUT
    bRun     : BOOL; (* Enabled *)
    tOffTime : TIME; (* Down Time of a pulse *)
    tOnTime  : TIME; (* Up Time of a pulse *)END_VAR

bRun: Aktiviert den Taktbaustein

tOffTime: Lange des Low Pegels

tOnTime: Länge des High Pegels

VAR_OUTPUT

      VAR_OUTPUT
    Q            : BOOL; (* PULSE *)END_VAR

Q: Ausgangssignal

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FUNCTION_BLOCK FB_SimDelay

Verzögerungsbaustein.

Ein binäres Eingangssignal 'bIn' wird um die Zeitdauer 't' ausgegeben. Die Verzögerung muss kürzer sein als die Input-Pulsdauer.

Bild 1: Funktionsblock FB_SIMDELAY

VAR_INPUT

      VAR_INPUT
    bIn  : BOOL;  (* Input pulse *)
    t     : TIME; (* Delay time of the pulse *)
END_VAR

bIn: Input Signal

t: Verzögerungszeit (sollte kleiner als die Pulsdauer sein)

VAR_OUTPUT

      VAR_OUTPUT
    Q     : BOOL; (* PULSE *)END_VAR

Q: Output Signal

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FUNCTION_BLOCK FB_SimDelayedLatch

Verzögertes Latch

Der Ausgang 'Q' wird gegenüber dem Eingang 'bIn' um eine bestimmte Zeit 'tDelay' verzögert. Weiterhin wird ein Ausgangs 'TRUE'-Pegel für eine Zeit 'tLatch' gehalten.

Bild 1: Funktionsblock FB_SIMDELAYEDLATCH

VAR_INPUT

      VAR_INPUT
    bEnable   : BOOL;    (* Activates the Latch *)
    bIn       : BOOL;    (* Input signal *)
    tDelay    : TIME;    (* Delay of the output signal *)
    tLatch    : TIME;    (* Latch time of the delayed output signal
*)END_VAR

bEnable: Aktiviert den Baustein

bIn: Eingangssignal

tDelay: Verzögerung des Ausgangssignals

tLatch: Haltezeit des TRUE Ausgangspegels

VAR_OUTPUT

      VAR_OUTPUT
    Q         : BOOL;    (* Output signal *)END_VAR

Q: Ausgangssignal

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FUNCTION_BLOCK FB_SimRamp

Rampenbaustein

Über den Rampenbaustein kann ein sich linear über die Zeit änderndes Signal simuliert werden. Das Signal initialisiert mit dem Wert 'fStart' und endet nach einer Zeitdauer von 'tRampTime' mit dem Wert 'fTarget'.

Bild 1: Funktionsblock FB_SIMRAMP

VAR_INPUT

      VAR_INPUT
    bEnable     : BOOL; (* Starts ramp with rising edge, Stops ramp with falling
edge *)
    fStart      : REAL; (* Start value *)
    fTarget     : REAL; (* Target value *)
    tRampTime   : TIME; (* Time needed from fStart to fTarget *)END_VAR

bEnable: Mit einer steigenden Flanke wird die Rampe gestartet, mit einer fallenden gestoppt

fStart: Startwert

fTarget: Zielwert

tRampTime: Zeitdauer von fStart bis FTarget

VAR_OUTPUT

      VAR_OUTPUT
    fOut          : REAL; (* Output value *)
    bValueReached : BOOL; (* Target value reached *)END_VAR

fOut: aktueller Wert

bValueReached: TRUE : Zielwert erreicht

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FUNCTION_BLOCK FB_SimDerivative

Ableitungsbaustein

Bild 1: Funktionsblock FB_SIMDERIVATIVE

VAR_INPUT

      VAR_INPUT
    bRun     : BOOL; (* 0 = Reset *)
    fIn      : REAL; (* Input for derivative *)END_VAR

bRun: Aktiviert den Baustein

fIn: Eingang für die Ableitung

VAR_OUTPUT

      VAR_OUTPUT
    fOut     : REAL; (* Derivative output *)END_VAR

fOut: Abgeleiteter Wert

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FB_SimIntegral

Integrierbaustein

Der Integrierbaustein integriert den Eingangswert 'fIn' über die Zeit. Als Zeitbasis wird die Zeitdifferenz verwendet, die zwischen zwei Aufrufen des Bausteins vergeht.

Bild 1: Funktionsblock FB_SIMINTEGRAL

VAR_INPUT

      VAR_INPUT
    bRun       : BOOL; (* Integrate 1, Hold 0 *)
    bReset     : BOOL; (* Reset *)
    XIN        : REAL; (* Input for Integral*)
    X0         : REAL; (* Initial value *)END_VAR

bRun: Aktiviert den Baustein

bReset: Initialisiert den Baustein mit dem Initialisierungswert in 'fInit'

fIn: Eingangswert zum Integrieren

fInit: Initialisierungswert

VAR_OUTPUT

      VAR_OUTPUT
    fOut       : REAL; (* Integral out, Integrated over milliseconds
*)END_VAR

fOut: Integrierter Wert

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FUNCTION_BLOCK FB_SimPastCpuCounterTicks

Zeitmessbaustein

Dieser Baustein misst die Zeit zwischen zwei Bausteinaufrufen in 100 ns Ticks.

Bild 1: Funktionsblock FB_SIMPASTCPUCOUNTERTICKS

VAR_INPUT

      VAR_INPUT
    bReset : BOOL; (* TRUE = > reset cpu counter tick measure
*)END_VAR

bReset: Initialisiert die Zeitmessung

VAR_OUTPUT

      VAR_OUTPUT
    (* one digit = 100 nanoseconds *)
    dwTicksLo : DWORD;    (* Low DWORD of the time delta *)
    dwTicksHi : DWORD;    (* High DWORD of the time delta *)END_VAR

dwTicksLo: Zeitdifferenz unteres DWORD (in 100ns Ticks)

dwTicksHi: Zeitdifferenz oberes DWORD (in 100ns Ticks)

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FUNCTION_BLOCK FB_SimPosMotor

Positionsgesteuerter Simulationsmotor.

Dieser Simulationsmotor fährt selbständig die übergebene Zielposition in einem rampenförmigen Geschwindigkeitsprofil an. Die Zielposition in 'fTargetPostion' wird mit einer positiven Flanke an 'bSet' übergeben. An den Ausgängen kann neben der momentanen Position, die aktuelle Geschwindigkeit und Beschleunigung abgegriffen werden.

Bild 1: Funktionsblock FB_SIMPOSMOTOR

VAR_INPUT

      VAR_INPUT
    bRun             : BOOL;
(* Motor running *)
    bSet             : BOOL;
(* Activates the move command *)
    fTargetPosition  : REAL;
(* Target Position ~(EUnit:mm)
*)
    fMaxVelocity     : REAL := 1000;
(* Maximal Velocity ~(EUnit:mm/s)
*)
    fMaxAcceleration : REAL := 100;
(* Maximal Acceleration ~(EUnit:mm/s^2
*)END_VAR

bRun: Aktiviert den Simulationsmotor

bSet: Übernahme der maximalen Geschwindigkeit und der Zielposition bei steigender Flanke

fTargetPosition: Zielposition in mm

fMaxVelocity: Maximale Geschwindigkeit in mm/s

fMaxAcceleration: Maximale Beschleunigung in mm/s^2

VAR_INPUT

      VAR_OUTPUT
    fPosition        : REAL := 0.0;
(* Current position ~(EUnit:mm)
*)
    bPositionReached : BOOL := TRUE;
(* Position reached *)
    fVelocity        : REAL := 0.0;
(* Current velocity ~(EUnit:mm/s)
*)
    fAcceleration    : REAL := 0.0;
(* Current acceleration ~(EUnit:mm/s^2)
*)END_VAR

fPosition: Momentane Position in mm

bPositionReached: TRUE wenn die vorbestimmte Position erreicht ist

fVelocity: Momentane Geschwindigkeit in mm/s

fAcceleration: Momentane Beschleunigung in mm/s^2

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FUNCTION_BLOCK FB_SimSimpleVeloMotor

Einfacher geschwindigkeitsgesteuerter Simulationsmotor.

Die Zielgeschwindigkeit und die maximale Beschleunigung werden an den Eingängen 'fTargetVelocity' und 'fMaxAcceleration' vorgegeben. Als Ausgänge stehen die momentane Position 'fPosition' (als Integral der Geschwindigkeit), die momentane Geschwindigkeit 'fVelocity' und die momentane Beschleunigung 'fAcceleration' zur Verfügung.

Bild 1: Funktionsblock FB_SIMSIMPLEVELOMOTOR

VAR_INPUT

      VAR_INPUT
    bRun                : BOOL;         (* Activates
the FB *)
    fTargetVelocity     : REAL;         (* Target
Velocity ~(EUnit:mm/s) *)
    fMaxAcceleration    : REAL :=
100;  (* Maximal valid acceleration
~(EUnit:mm/s^2 *)END_VAR

bRun: Aktiviert den Simulationsmotor

fTargetVelocity: Zielgeschwindigkeit in mm/s

fMaxAcceleration: Maximale Beschleunigung in mm/s^2

VAR_OUTPUT

      VAR_OUTPUT
    fPosition           : REAL :=
0.0;     (* Current Position ~(EUnit:mm)
*)
    fVelocity           : REAL :=
0.0;     (* Current Velocity ~(EUnit:mm/s)
*)
    fAcceleration       : REAL :=
0.0;     (* Current Acceleration
~(EUnit:mm/s2) *)
    bVelocityReached    : BOOL :=
TRUE;    (* Velocity is reached
*)END_VAR

fPosition: Momentane Position in mm

fVelocity: Momentane Geschwindigkeit in mm/s

fAcceleration: Momentane Beschleungung in mm/s^2

bVelocityReached: TRUE = Zielgeschwindigkeit erreicht

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


FUNCTION_BLOCK FB_SimVeloMotor

Geschwindigkeitsgesteuerter Simulationsmotor.

Eine positive Flanke im Eingang 'bSet' setzt die Zielgeschwindigkeit 'fTargetVelocity' und die maximale Beschleunigung 'fMaxAcceleration'. Die momentane Position 'fPosition', die momentane Geschwindigkeit 'fVelocity' und die momentane Beschleunigung 'fAcceleration' stehen als Ausgänge zur Verfügung.

Bild 1: Funktionsblock FB_SIMVELOMOTOR

VAR_INPUT

      VAR_INPUT
    bRun             : BOOL;
(* Activates the FB *)
    bSet             : BOOL;
(* Sets the Preset Velcity and Maximum
Acceleration *)
    fTargetVelocity  : REAL;
(* Preset Velocity ~(EUnit:mm/s)
*)
    fMaxAcceleration : REAL := 100;
(* Maximum Acceleration ~(EUnit:mm/s^2
*)END_VAR

bRun: Aktiviert den Simulationsmotor

bSet: Eine positive Flanke setzt die Zielgeschwindigkeit und die maximale Beschleunigung

fTargetVelocity: Zielgeschwindigkeit in mm/s

fMaxAcceleration: Maximale Beschleunigung in mm/s^2

VAR_OUTPUT

      VAR_OUTPUT
    fPosition        : REAL := 0.0;
(* Current Position ~(EUnit:mm)
*)
    fVelocity        : REAL := 0.0;
(* Current Velocity ~(EUnit:mm/s)
*)
    fAcceleration    : REAL := 0.0;
(* Current Acceleration ~(EUnit:mm/s^2)
*)
    bVelocityReached : BOOL := TRUE;
(* Preset velocity is reached *)END_VAR

fPosition: Momentane Position in mm

fVelocity: Momentane Geschwindigkeit in mm/s

fAcceleration: Momentane Beschleunigung in mm/s^2

bVelocityReached: Zielgeschwindigkeit erreicht

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


First Steps

Vorraussetzungen:

  • Die Original (zu simulierenden) SPS-Projekte sind verfügbar und auf den Zielsystemen aktiviert.
  • Die SPS-Projekte sollten die "TcSimMan.lib" referenzieren um die Simulations-Umschaltung voll zu Unterstützen.
  • Zumindest eine SPS Laufzeit muß auf dem lokalen (lokale Simulation) oder einem verfügbaren "Remote" System (verteilte Simulation) verfügbar sein.
  • Alle beteiligten Systeme müssen gültige Konfigurationen aktiviert haben.
  • Die Zielsysteme müssen die Symboldefinitionen aller SPS-Projekte enthalten.
  • Die Zielsysteme müssen alle SPS Laufzeiten als "Bootprojekt" definiert haben.

siehe auch Simulationsvorrausetzungen.

Erzeugung eines neuen TwinCAT Simulation Manager Projektes

Wähle "Datei --> Neu" im Hauptmenü (siehe Bild 1)

Bild 1: Öffnen eines neuen TwinCAT Simulation Manager Projektes

Der "Neues Projekt Öffnen" Dialog erscheint und ein gültiger Projektname und Verzeichnis muss eingegeben werden (siehe Bild 2).

Bild 2: "Neues Projekt Öffnen" Dialog

Nach dem Bestätigen mit "OK" erzeugt der TwinCAT Simulation Manager ein Projektverzeichnis und eine Projektdatei.

Um eine Simulations-Konfiguration zu erzeugen müssen im nächsten Schritt die Zielsysteme mit den originalen (zu simulierenden) Projekten und Konfigurationen angegeben werden. Dafür muß "Bearbeiten --> Zielsysteme auswählen ..." im Hauptmenü ausgewählt werden (siehe Bild 3). Daraufhin öffnet sich der "Hinzufügen der Original-Systeme" Dialog (Bild 4). Der Dialog zeigt alle erreichbaren TwinCAT Systeme innerhalb der angschlossenen Subnetzwerke.

Bild 3: Einfügen von Zielsystemen

Innerhalb dieses Dialoges müssen alle zu simulierenden (originalen) Zielsysteme in der Liste rechts hinzugefügt werden (über die Taste ">>"). Mit der Bestätigung über "OK" fügt der TwinCAT Simulation Manager die ausgwählten Zielsystem zu der Simulations-Konfiguration hinzu. Wenn ein Zielsystem nicht als Route am lokalen System angemeldet ist, wird diese als statische Route durch den TwinCAT Simulation Manager nach Rückfrage vorgenommen.

Wenn der Zugriff auf die Zielsysteme möglich ist, werden deren aktuellen Konfigurationen lokal im Cache gespeichert. Dasselbe passiert für alle PLC Symbol Beschreibungen (*.tsm Dateien), welche auf den Zielsytemen aktiv sind.

Bild 4: Auswahl der Zielsysteme

Wenn alle notwendigen Informationen gefunden und erfolgreich heruntergeladen wurden zeigt der TwinCAT Simulation Manager Navigationsbaum ("Konfiguration") die eingebundenen Zielsysteme (Bild 5).

Erzeugen einer neuen Simulations-SPS

Bis jetzt enthält das TwinCAT Simulation Manager Projekt nur die Original (zu simulierenden) SPS Systeme. Eine Erzeugung einer neuen Simulations-SPS wird wie folgt angestoßen:

  1. Auswahl der SPS Laufzeit, die simuliert werden soll (im Navigationsbaum, siehe Bild 5).
  2. Aufruf von "Erzeuge Simulations SPS-Projekt" aus dem Kontextmenü.
  3. Innerhalb des nun erscheinenden Dialoges, muss eine freie SPS Laufzeit für das SImulations-SPS-Projekt ausgewählt werden (Bild 6). Dieser Dialog zeigt die momentan erreichbaren Zielsyteme. Wenn das vorgesehene Ziel nicht dabei ist, kann es über den "Suchen" Schalter hinzugefügt werden.
  4. Mit dem Verlassen des Dialoges über "OK" erzeugt der TwinCAT Simulation Manager einen Simulations-Projekt-Rahmen für die ausgewählte SPS, ordnet diesen dem ausgewählten Zielsystem bzw. der ausgewählten SPS-Laufzeit zu und integriert das SPS Projekt in das TwinCAT Simulation Manager Konfigurations-Projekt.
    Dieser Simulations-SPS-Rahmen enthält nun alle lokierten EA-Symbole des Original-Projektes in gespiegelter From (Eingänge --> Ausgänge u. Ausgänge --> Eingänge) (Bild 7). Der nächste Schritt ist diesesn Rahmen mit Applikations-spezifischem Simulations-Code zu füllen Dafür kann das TwinCAT PLCControl Programm über das Kontextmenü "Öffne PlcControl ..." geöffnet werden.

Bild 5: Erzeugung des Simulations-SPS-Projektes

Bild 6: Auswahl der SPS-Laufzeit für die Simulation

Bild 7: Erzeugtes Simulations-SPS-Rahmenprojekt in der TwinCAT Simulation Manager Configuration

In Bild 7 ist zu erkennen, dass der TwinCAT Simulation Manager aus dem Original-Projekt spiegelbildliche Symbole demselben Namens in das Simulations-Projekt erzeugt. Diese Namensgleichheit kann durch einen intelligenten Automatismus zur Default-Verknüpfung von Original- und Simulations-SPS ausgenutzt werden.

Einfügen eines existierenden Simulations-SPS-Projektes

Ein existierendes Simulations-SPS-Projekt wird wie folgt eingefügt:

  1. Hinzufügen des Zielsystems über "Edit->"Adding the target system to the list of project systems with calling "Beabeiten -> Zielsystem hinzufügen" im Hauptmenü (Bild 3 und Bild 4).
  2. Aufruf von "Beabeiten -> SPS Projekt Zuordnungen ..." im Hauptmenü (Bild 8).
  3. Zuordnung des Simulations-SPS-Projektes zur Original-SPS (Bild 9).

Bild 8: Aufruf des "SPS Projekt-Zuordnung Ändern" Dialoges

Bild 9: Zuordnung von Original-SPS zu Simulations-SPS

Konfiguration des Simulations-Modus

Der Projektstand ist nun wie folgt:

Die Original- und Simulations-Zielsytseme sind nun zugeordnet und zumindest die Interfaces (Simulations-Rahmen) der Simulations-Funktionalität wurden generiert. Um nicht-existente Geräte oder Sensorik zu ersetzen, müssen noch weitere Einstellungen an der Simulations-Konfiguration vorgenommen werden:

  • Deaktivierung von nicht vorhandenen Geräten
  • Versetzen von nicht vorhandenen Achsen und Antrieben in den Simulationsmodus
  • Ersetzen von Sensoren und Aktoren durch die Simulations-SPS

Die nicht vorhandenen Geräte werden wie in Bild 10 und Bild 11 gezeigt deaktiviert. Das rote 'S' kenzeichnet diejenige Hardware, welche im Simulations-Modus deaktiviert ist.

Bild 8: Deaktivierung von nicht existenter Hardware

Bild 9: Deaktivierte Hardware

Die Simulation von Achsen und Antrieben wird über das KontextMenü in der Achsen-Liste konfiguriert (Bild 12).

Bild 10: Simulation von Achsen und Antrieben

Zuletzt muss das vorher hinzugefügte Simulations-SPS-Projekt an die Original-SPS angebunden werden. Dazu gibt es zwei Möglichkeiten:

  1. Die manuelle Zuordnung Symbol für Symbol, oder
  2. Ausnutzung des automatisierten Zuordnungs Algorithmus.

Bild 11: Simulations Symbole ohne Zuordnung auf die Original-SPS

Die manuelle Zuordnung erfolgt durch einfaches aktivieren der Checkbox oder Aufruf des Kontextmenüs auf dem gewünschten Symbol (siehe Bild 13) innerhalb der Symbol Zielansicht (List-View rechts oben). Abhängig von der Symbol-Auswahl im linken Navigationsbaum sammelt die "Symbol Zielansicht) alle Original- oder Simulations-Symbole desselben Datentypes. Es kann jedes dieser Ziel-Symbole dem Quellsymbol zugeordnet werden.

Die intelligente automatische Zuordnung wird angestossen, wenn "Bearbeiten --> Erzeuge Standard Verknüfungen" im Hauptmenü (Bild 14) angestossen wird. Diese Funktionalität iteriert über alle vorhandenen Symbole innerhalb der Original-SPS-Projekte und bindet sie an Simulations-Symbole mit gleichem Namen / Zugriffpfad, gleichem Datentyp aber spiegelbildlicher Lokierung (siehe Bild 15).

Im allgemeinen bildet diese automatische Zurdnung einen guten Ausgangspunkt für eine Simulations-Konfiguration, welche dann über die manuelle Zuordnung noch angepasst werden kann.

Bild 12: Automatisches Erzeugen von Standard-Zuordnungen

Bild 15: Simulations Symbole zugeordnet zur Original-SPS

Wechseln des Simulations-Maschinen-Modus (Original <--> Simulation)

Wenn das Simulations-Projekt fertig konfiguriert ist kann über den TwinCAT Simulation Manger der Simulations-Maschinen-Modus umgeschaltet werden. Dies geschieht im HauptMenü über toggeln von "Bearbeiten->Simulieren" oder in der ControlBar über toggeln des Simulations-Icon.

Weil der Übergang von Original- zu Simulations-Modus und umgekehrt mehrere sicherheitsrelevante vom Anwender zu bestätigende Schritte enthält, wird dieser Prozess durch einen Wizard Dialog Schritt-für-Schritt unterstützt.

Diese Vorgänge werden auf den folgenden Seiten dargestellt:

  • Wechseln zum Simulations-Modus
  • Wechseln zum Original-Modus

TwinCAT Simulation Manager

Löschen von Simulations-Einstellungen

Alle Simulations-Einstellungen und Konfigurationen können im Hauptmenü über "Bearbeiten -> Verwerfe Simulations-Einstellungen ..." gelöscht werden.


FAQ (Häufig gestellte Fragen)

Fehlermeldung: "Die System Manager Konfigurationsdatei 'XXX.wsm' kann nicht geöffnet werden. Wahrscheinlich ist die Datei durch eine andere System Manager Instanz blockiert!"

Fehlermeldung: "Die PlcControl Symbol Datei für das Projekt 'XXX' wurde nicht gefunden. Die System Manager Konfiguration muss korrigiert werden, bevor sie benutzt werden kann!"

Das neu erzeugte Simulations-SPS-Projekt enthält keine Ein- und Ausgänge.

Das System meldet "Die System Manager Konfigurationsdatei 'XXX.wsm' kann nicht geöffnet werden. Wahrscheinlich ist die Datei durch eine andere System Manager Instanz blockiert!"

Problem:

Der 'TwinCAT System Manager' wird vom 'TwinCAT Simulation Manager' als 'Out-of-process'-COM-Server angesprochen. Sie laufen als zwei verschiedene Prozesse (EXE-Files), die miteinander kommunizieren.

Es kommt nun zu dieser Fehlermeldung, wenn ein System Manager Prozess nicht mehr angesprochen werden kann. Da keine zweite System Manager Instanz auf derselben Konfigurationsdatei gestartet werden darf ist das System blockiert.

Lösung:

Der blockierte System Manager Prozess muss beendet werden. Dazu führen sie bitte die folgenden Schritte aus:

  1. Router Cleanup (in manchen Fällen reicht dieser Schritt schon)

  2. Den System Manager Prozess beenden
  3. Wenn sich der System Manager Prozess nicht beendet, sollte noch einmal ein Router Cleanup angestoßen werden. Spätestens jetzt sollte sich der System Manager Prozess beenden!

Fehlermeldung:
"Die PlcControl Symbol Datei für das Projekt 'XXX' wurde nicht gefunden. Die System Manager Konfiguration muss korrigiert werden, bevor sie benutzt werden kann!"

Problem:

Die im System Manager angegebene Symbol Datei (*.tpy) konnte nicht gefunden werden!

Lösung:

Verbinden Sie in der System Manager Konfiguration die Symbol Datei erneut und lesen die Symbolik neu ein ("Rescan").

Das neu erzeugte Simulations-SPS-Projekt enthält keine Ein- und Ausgänge

Problem:

Die folgenden Bedingungen müssen zu erzeugen von lokierten Variablen erfüllt sein:

  • Die Original-SPS-Projekte müssen lokierte Variablen enthalten, die dann in das Simulations-SPS-Projekt exportiert werden können.
  • Die Simulations-SPS-Symbole müssen im Simulations-Projekt benutzt werden
  • Das Simulations-SPS-Projekt muß kompiliert sein.

Lösung:

Bitte kontrollieren Sie ob in der Simulations-SPS Symbole erzeugt wurden und diese dann auch benutzt werden, da der Codeerzeuger nicht benutzte Symbole bei der Compilation ignoriert. Aufrufe von Programm-POEs werden nicht in der Simulations-SPS erzeugt, sie müssen eventuell nachgepflegt werden. .

Achten Sie auch darauf, daß die benutzten Symbol-Adressbereiche groß genug sind. Der PLC Control Compiler erzeugt dann folgende Fehler:

Error: Variable 'X' to large for address %ADDRESS

Vergrößern Sie in diesm Fall den Speicher in den ProjektOptionen des betreffenden SPS-Projektes.

Wenn das Simulations-SPS-Projekt nun fehlerfrei kompiliert ist, lassen sich die Symbole im Simulations Manager durch "Neu einlesen" auf dem entsprechenden SPS-Knoten aktualisieren.


FUNCTION_BLOCK FB_SimPID

Simulations PID-Regler

Bild 1: Funktionsblock FB_SIMINTEGRAL

VAR_INPUT

VAR_INPUT
bAuto : BOOL; (* 0 - Manual, 1 - Automatic *)
fProcessValue : REAL; (* Process value *)
fSetPoint : REAL; (* Set point *)
fX0 : REAL; (* Manual output adjustment *)
fKp : REAL; (* Proportional constant *)
tResetTime : REAL; (* Reset Time *)
tDerTimeConst : REAL; (* Derivative Time constant *)
END_VAR

bAuto: TRUE: PID-Berechnung an, FALSE: PID-Berechnung aus

fProcessValue: Istwert

fSetPoint: Sollwert

fX0:

fKp: Proportionale Konstante

tResetTime: Nachstellzeit (Tn)

tDerTimeConst: Vorhaltezeit (Tv)

VAR_OUTPUT

VAR_OUTPUT
fOut : REAL; (* PID Output *)
END_VAR

fOut: Stellgröße

Development Environment | Target System | PLC Libraries to include
TwinCAT v2.9.0 Build > 1020 | PC (i386) | TcSimManager.Lib (Standard.Lib; TcBase.Lib; TcSystem.Lib are included automatically)

Tabelle 1: Unterstützung von TwinCAT Versionen


Installation

  1. Stellen Sie sicher, daß die Microsoft .NET Framework Version 2.0 oder höher auf Ihrem System installiert ist!

  2. Stellen Sie sicher, daß die auf Ihrem System installierte TwinCAT-Version neuer oder gleichTwinCAT 2.10 Build 1325 ist!

  3. Installieren Sie den TwinCAT Simulation Manager mit Setup.exe.